package com.zhuangzi.ssm0925.controller.admin;

import com.zhuangzi.ssm0925.entity.Sorts;
import com.zhuangzi.ssm0925.service.SortsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

@Controller
public class SortsController {
    @Autowired
    @Qualifier("sortsService")
    private SortsService sortsService;
    @GetMapping(value = "/admin/sorts/add")
    public String add(@RequestParam(defaultValue = "0") Integer parentId,Model model){
        System.out.println("当前的parentid:" + parentId);
        model.addAttribute("selectTrees",sortsService.selectTrees(0,parentId));
        return "admin/sorts/add";
    }
    @PostMapping(value = "/admin/sorts/addSave")
    public void addSave(Sorts sorts, HttpServletResponse response) throws IOException {
        response.setContentType("text/html;charset=utf-8");
        PrintWriter out = response.getWriter();
        out.println(sortsService.addSorts(sorts));
    }
    @GetMapping(value = "/admin/sorts/list")
    public String list(Model model){
        ArrayList<Sorts> all = sortsService.getChildren(0,"",null);
        model.addAttribute("all",all);
        return "admin/sorts/list";
    }
    @GetMapping(value = "/admin/sorts/update")
    public String update(@RequestParam(defaultValue = "0") Integer id,Model model){
        Sorts sorts = sortsService.selectSortsById(id);
        model.addAttribute("sorts",sorts);
        model.addAttribute("selectTrees",sortsService.selectTrees(0,sorts.getParentId()));
        return "admin/sorts/update";
    }

    @PostMapping(value = "/admin/sorts/updateSave")
    public void updateSave(Sorts sorts, HttpServletResponse response) throws IOException{
        response.setContentType("text/html;charset=utf-8");
        PrintWriter out = response.getWriter();
        out.println(sortsService.updateSorts(sorts));
    }

    @GetMapping(value = "/admin/sorts/del")
    public void del(@RequestParam(defaultValue = "0") Integer id, HttpServletResponse response) throws IOException{
        response.setContentType("text/html;charset=utf-8");
        PrintWriter out = response.getWriter();
        out.println(sortsService.deleteAllSortsById(id));
    }
}
