package com.zhuangzi.ssm0925.controller.admin;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.zhuangzi.ssm0925.entity.Student;
import com.zhuangzi.ssm0925.service.StudentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Controller
@RequestMapping("/admin/student/")
public class StudentController {
    @Autowired
    private StudentService studentService;
    //注意这里： StudentService  是个接口, Spring会找实现接口的类来实例化

    @PostMapping("add")
    @ResponseBody
    public Map addStudent(Student student){
        System.out.println(student.getSex());
        studentService.addStudent(student);
        //控制器调用服务，服务调用dao
        Map map = new HashMap();
        map.put("code",0);
        map.put("msg","success");
        map.put("id",student.getId());
        return map;
    }

    @GetMapping("delete")
    @ResponseBody
    public Map deleteStudent(Integer id){
        studentService.deleteStudent(id);
        //控制器调用服务，服务调用dao
        Map map = new HashMap();
        map.put("code",0);
        map.put("msg","success");
        return map;
    }

    @GetMapping("list")
    public String getListStudent(Student student, Model model, @RequestParam(defaultValue = "1") Integer page){
        PageHelper.startPage(page,2);//开始分页
        //page: 第几页
        //2   : 每页显示的条数

        List<Student> list = studentService.getListStudent(student);
        PageInfo<Student> pageInfo = new PageInfo<Student>(list);
        //封装分页数据
        model.addAttribute("list",list);
        model.addAttribute("totalPage",pageInfo.getPages());
        System.out.println(pageInfo.getTotal());
        return "admin/student/list";
    }


}
