package com.zhuangzi.ssm0925.service;


import com.zhuangzi.ssm0925.dao.SortsDao;
import com.zhuangzi.ssm0925.entity.Sorts;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;

@Service("sortsService")
public class SortsServiceImpl implements SortsService{
    public static int initLevel = 0;
    @Autowired
    private SortsDao sortsDao;

    public static ArrayList<Sorts> all;  //存储所有的查询子类数据
    @Override
    public String addSorts(Sorts sorts) {
        //判断类名不能为空
        if(sorts.getSortName().equals("")) {
            return "<script>alert('类别名称不能为空');history.back();</script>";
        }
        //判断同一级下不能重复的名称
        if(sortsDao.selectBySortNameAndParendId(sorts) != null){
            return "<script>alert('父类下已存在相同类别!!!');history.back();</script>";
        }
        //设置level, sortpath 信息  begin
        sorts.setLevels(1);
        sorts.setSortPath("0,");
        if(sorts.getParentId() != 0){
            //最顶级时使用默认设置值， 否则根据父级来决定
            Sorts getSorts = sortsDao.selectSortsById(sorts.getParentId());
            sorts.setLevels(getSorts.getLevels() + 1);
            sorts.setSortPath(getSorts.getSortPath());
            //暂时为父级sortPath, 当添加后， 再更新，将当前的id链接上
        }

        //将信息添加到数据库sorts
         sortsDao.addSorts(sorts); //sorts中会更新为新增加的id主键

        //更新sortPath 到数据库
         sorts.setSortPath(sorts.getSortPath() + sorts.getId() + ",");
         sortsDao.updateSorts(sorts);//
         return "<script>alert('添加成功');location.href='/admin/sorts/list';</script>";
    }


    //parentId:  父类 ID, 查询当前类别下的所有子类
    //space :  // 类别前面的空隔
    @Override
    public  ArrayList<Sorts> getChildren(int parentId, String  space, ArrayList<Sorts> arr){
        if(arr == null){
            //第一次查询
            System.out.println(parentId);
            arr = sortsDao.selectByParentId(parentId);
            initLevel = arr.get(0).getLevels();
            all = new ArrayList<>(); //第一次时， 初始化， 避免刷新调用重新添加信息
        }
        if(arr != null){
            for(Sorts sorts : arr){
                //根据级别不一样, 在前面加上相应的分隔符
                int levels = sorts.getLevels();
                if(levels == initLevel){
                    sorts.setSpace("");
                }
                else if(levels == initLevel + 1){
                    space = "　　|---->";
                    sorts.setSpace(space);
                }
                else{
                    sorts.setSpace(space);
                }
                all.add(sorts); //将所有的信息都加到all里， 并增加一个space字段
                parentId = sorts.getId();
                ArrayList<Sorts> arr_child = sortsDao.selectByParentId(parentId);
                if(arr_child != null){
                    getChildren(parentId,"　　|" + space,arr_child);
                }
            }
        }
        return  all;
    }
    //得到无限分类的select下拉列表
    //pid : 父id
    //selectName select的名字
    //currenId : 被选择的id, 没有的话,传递0
    @Override
    public StringBuffer selectTrees(int pid,int currentId){
        StringBuffer sBuffer = new StringBuffer();
        ArrayList<Sorts> results = getChildren(pid,"",null);
        if(results != null){
                for(Sorts sorts : results){
                    int id = sorts.getId();
                    if( id == currentId){
                        sBuffer.append("<option value='"+id+"' style='background:#E20A0A; color:#fff;' selected>"+
                                sorts.getSpace() + sorts.getSortName() + "</option> \n");
                    }
                    else{
                        sBuffer.append("<option value='"+id+"'>"+ sorts.getSpace() + sorts.getSortName() + "</option> \n");
                    }
                }
        }
        return  sBuffer;
    }

    @Override
    public Sorts selectSortsById(Integer id) {
        return sortsDao.selectSortsById(id);
    }

    @Override
    public String updateSorts(Sorts sorts) {
        //判断类名不能为空
        if(sorts.getSortName().equals("")) {
            return "<script>alert('类别名称不能为空');history.back();</script>";
        }
        //根据id得到原来的信息
        Sorts oldSorts = sortsDao.selectSortsById(sorts.getId());
        int oldPid = oldSorts.getParentId(); //原父id
        String oldSortPath = oldSorts.getSortPath();
        //判断类别名称是否重复
        Sorts exitSorts = sortsDao.selectSortsByParentIdSortNameId(sorts);
        if(exitSorts != null){
            return "<script>alert('类别已经存在,请更换类别名称');history.back();</script>";
        }
        if(oldPid == sorts.getParentId()){
            //父id不变, 则parentid, level都不需要修改
            sortsDao.updateSortsBySortNameOrdersId(sorts);
        }
        else if(sorts.getParentId() == 0){
            //移动到一级类别
            sorts.setSortPath("0," + sorts.getId() + ",");
            sorts.setLevels(1);
            //更新当前类别信息
            sortsDao.updateSorts(sorts);

            //更新所有的修改类别的子类sortPath
            HashMap<String,Object> hm = new HashMap<>();
            hm.put("oldSortPath",oldSortPath);
            hm.put("newSortPath",sorts.getSortPath());
            hm.put("id",sorts.getId());
            sortsDao.updateAllChildSorts(hm);
            //更新所有子类的层级
            sortsDao.updateAllChildSortsLevels(hm);
        }
        else{
            //判断是否移到到了子类另， 这样是不允许的， 中间会断层
            //得到当前父类的path
            Sorts parentSorts = sortsDao.selectSortsById(sorts.getParentId());
            String parentSortPath = parentSorts.getSortPath();
            if(parentSortPath.indexOf(oldSortPath) >= 0){
                return "<script>alert('类别不能选择为原父类的子类');history.back();</script>";
            }
            else{
                //父类更新到上一级或者其它的类别下, 那么该类别下所有的子类都需要更新父级sortpath
                //新的sortpath
                String newSortPath = parentSortPath + sorts.getId() + ",";
                int    newLevel    = parentSorts.getLevels() + 1;
                sorts.setSortPath(newSortPath);
                sorts.setLevels(newLevel);
                sortsDao.updateSorts(sorts);
                //更新所有的修改类别的子类

                //更新所有的修改类别的子类sortPath
                HashMap<String,Object> hm = new HashMap<>();
                hm.put("oldSortPath",oldSortPath);
                hm.put("newSortPath",sorts.getSortPath());
                hm.put("id",sorts.getId());
                sortsDao.updateAllChildSorts(hm);
                //更新所有子类的层级
                sortsDao.updateAllChildSortsLevels(hm);
            }
        }
        return "<script>alert('修改成功');location.href='/admin/sorts/list';</script>";
    }

    //删除所有的子类
    @Override
    public String deleteAllSortsById(Integer id) {
        sortsDao.deleteAllSortsById(id);
        return "<script>alert('删除成功');location.href='/admin/sorts/list';</script>";
    }



}
